# 4.4.2. The format of CoAP messages

As we have just seen, in addition to the information to be transmitted, CoAP messages must contain a set of information relating to the two previously described layers. Messages are encoded in a simple binary format, with a well-defined structure: messages start with a fixed header of 4 bytes (32 bits), followed by a “Token” field of variable size between 0 and 8 bytes. There is then a field for options, and, lastly, the data occupying the rest of the datagram, preceded by a separator of one byte containing the value "1111111".

<img src="Images/figure2.png" width="538" height="180" />

Figure 2: The format of a CoAP message

In detail, a CoAP message contains the following information :
* **Version (Ver)** (2 bits): indicates the CoAP version number used (‘01’ by default).
* **Type (T)** (2 bits): indicates the type of message in the context of a request or response.
    - Request:
      + 0: ___Confirmable (CON)___ : This message expects a corresponding acknowledgement message.
      + 1: ___Non-confirmable (NON)___ : This message is not waiting for an acknowledgement message.
    - Response:
      + 2: ___Acknowledgement (ACK)___ : This message is a response that acknowledges a confirmable message.
      + 3: ___Reset (RST)___ : This message indicates that a message has been received which cannot be processed.
* **Token Length (TKL)** (4 bits): indicates the length of the Token field, which can vary from 0 to 8 bytes.
* **Code** (8 bits): indicates (with the format X.xx: 3-bit class and 5-bit detail) whether the message is a request, a response or an empty message. For requests, it will also indicate the method used (GET, POST, PUT or DELETE); for responses, contains a code which identifies the nature of the response. Unlike HTTP, it is coded in binary in the message.
* **Message ID** (16 bits):  serial number of the message, used to detect duplicate messages and to match an ACK/RST message with its initial CON/NON message.
* **Token** (0 - 8 bytes): field whose value is generated by the client, and whose size is indicated by the TKL field, used to match a request with the response. For example in the case of an empty acknowledgement that precedes a subsequent response.
* **Options**: contains additional information related or not to the type of the message. It is the equivalent of HTTP headers with for example the "Max-Age" parameter to define the validity period of the transmitted data.
* **Payload**: contains the data transmitted by the application (the payload start marker is 0xFF). The size of the payload must not exceed 1024 bytes but a CoAP data block transfer mechanism called "Block-Wise" allows the sending of different fragments each considered as a message.
